;
; Dabble with SC/MP. 
;
; Author doug rice
;
; usage: ./rcasm test4.asm -l -h -t

;
; usage: ./asm test4.asm -l -h -t
;
; use simulator:-
;
; This code puts a constant onto the hex display
; Press 8 to increment counter
; Press 0 to decrement counter
;
; This is displayed
;

start: 

8060{
;
; Try and write someting to the display at 0d00h
;
;	
Disp:	equ 0d00H
ChRom:	equ 010bH

	org	0f20H
	jmp	mainloop1


t:	db	0
cnt1:	DB	0
cnt2:	DB	0

IPkeys:	DB	0
IPlastkeys:	DB	0
IPpressed:	DB	0

t2:	db	0



IPkeyScan:
	; reload display pointer.
	LDI	Disp.0
	XPAL	1
	LDI	Disp.1
	XPAH	1

	; read switches and put onto the display
	; XOR
	; -----_____ lastkeys
	; ------____ keys
	; _____-____ 
	;
	
	; AND
	; _____----- ~lastkey
	; ------____ keys
	; _____-____
	;


	ldr	IPkeys
	xri	0ffh
	str	IPlastkeys

	; read switch
	LD	0(1)
	xri	0ffh
	str	IPkeys
	
	; invert
	andr	IPlastkeys

	; xri	0ffh
	str	IPpressed

	ani	040h
	; 1's represent keys pressed.
	jz	IPkeyScan1

IPkey8ev:
	; 8 pressed, increment counter
	ildr	cnt1

IPkeyScan1:
	; invert
	ldr	IPpressed
	ani	080h
	; 1's represent keys pressed.
	jz	IPkeyScan2

IPkey0ev:
	; 0 pressed, decrement counter        
	dldr	cnt1

IPkeyScan2:
	ldr	IPpressed
	ani	010h
	; 1's represent keys pressed.
	jz	IPkeyScan3

IPkeyAev:
	; A pressed, shift left  counter        
	ldr 	cnt1
	; double accumulator
	addr	cnt1
	str	cnt1	


;
; The code got too big for relative addressing
; so have jumps in the middle to allow for this.
;
IPkeyScan3:
	jmp	mainloop1

mainloop:
	jmp	IPkeyScan

mainloop1:

	ldr	cnt1
	st	7(1)
	dly	10


;	LD	0(1)
;	xri	-1
;	st	@+1(1)
;	dly	10

;	LD	0(1)
;	st	@+1(1)
;	dly	10

	; set pointer to Character rom @ 0x010b
	; instead of setting P2.lo = 0b, set it to cnt.
	; then use offset of 0bh to look up mapping to segments.
 
	LDI	ChRom.1
	XPAH	2
	
	; load cnt in xpal and use offset 
	ldr 	cnt1
	ani	0Fh
	XPAL	2

	; 
	ld	ChRom.0(2)
	; store onto display
	st	@+1(1)
	dly	10

	; load cnt in xpal and use offset 
	ldr 	cnt1
	rr
	rr
	rr
	rr
	ani	0Fh
	XPAL	2
	ld	ChRom.0(2)
	; store onto display
	st	@+1(1)
	dly	10


	; set pointer o Character rom @ 0x010b 
	LDI	ChRom.0
	XPAL	2
	LDI	ChRom.1
	XPAH	2
	
	; store onto display
	ldi	0
	st	@+1(1)
	dly	10


	;nop
	;ldi	055h
	; increment accumulator and store to display

	ldi	005h
	xae
	
	;
	; use value in E to lot up 7Seg 
	ld	-128(2)
	; store onto display
	st	@+1(1)

	dly	10
	ldi	002h
	xae
	
	; use value in E to lot up 7Seg 
	ld	-128(2)
	; store onto display
	st	@+1(1)

	dly	10

	ldi	008h
	xae
	
	; use value in E to lot up 7Seg 
	ld	-128(2)
	; store onto display
	st	@+1(1)

	ldi	000h
	xae
	; use value in E to lot up 7Seg 
	ld	-128(2)
	; store onto display
	st	@+1(1)
	

loop3:	
	jmp	mainloop

Stop:
	xppc 3
	jmp stop



}


